# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/org/jboss/security/jboss-negotiation/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion 2.0.3.SP3

Name:           jboss-security-negotiation
Version:        2.0.3
Release:        2.SP3.3%{?dist}
Epoch:          0
Summary:        JBoss Security Negotiation
License:        LGPL
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export https://svn.jboss.org/repos/jbossas/projects/security/security-negotiation/tags/security-negotiation-2.0.3.SP03 jboss-security-negotiation-2.0.3.SP3
# Exported revision 105678.
# tar czf jboss-security-negotiation-2.0.3.SP3.tar.gz jboss-security-negotiation-2.0.3.SP3
Source0:        jboss-security-negotiation-2.0.3.SP3.tar.gz
Source1:        jboss-security-negotiation-jpp-depmap.xml
Source2:        jboss-security-negotiation-settings.xml
Source3:        %{name}-component-info.xml
Patch0: jboss-security-negotiation-sx.patch

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  junit
BuildRequires:  jboss-common-core
BuildRequires:  jboss-parent
# jboss5-libs has poms that incorrectly bring all but the kitchen sink
#BuildRequires:  jboss5-libs
# Using jbossas directly for now
BuildRequires:  jbossas
BuildRequires:  jbosssx2
BuildRequires:  jbossweb
BuildRequires:  log4j
BuildRequires:  xpp3-minimal

Requires:  java >= 0:1.5.0
Requires:  jboss-common-core
Requires:  jbosssx2
Requires:  jbossweb
Requires:  log4j

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss Security Negotiation.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %{with_repolib}
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q -n %{name}-%{namedversion}
%patch0 -p0
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

# fix version typo in all pom.xml
for pom in $(find . -name pom.xml); do
    sed -i "s|<version>2.0.3.SP03</version>|<version>2.0.3.SP3</version>|g" $pom
done

%build
cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.depmap.file=%{SOURCE1} -Daggregate=true"

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy

mvn-jpp -e \
        -s ${M2SETTINGS} \
        javadoc:javadoc


%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 assembly/target/jboss-negotiation.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.jboss.security jboss-negotiation %{namedversion} JPP %{name}
install -m 644 jboss-negotiation-common/target/jboss-negotiation-common.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-common-%{version}.jar
%add_to_maven_depmap org.jboss.security jboss-negotiation-common %{namedversion} JPP %{name}-common
install -m 644 jboss-negotiation-extras/target/jboss-negotiation-extras.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-extras-%{version}.jar
%add_to_maven_depmap org.jboss.security jboss-negotiation-extras %{namedversion} JPP %{name}-extras
install -m 644 jboss-negotiation-ntlm/target/jboss-negotiation-ntlm.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-ntlm-%{version}.jar
%add_to_maven_depmap org.jboss.security jboss-negotiation-ntlm %{namedversion} JPP %{name}-ntlm
install -m 644 jboss-negotiation-spnego/target/jboss-negotiation-spnego.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-spnego-%{version}.jar
%add_to_maven_depmap org.jboss.security jboss-negotiation-spnego %{namedversion} JPP %{name}-spnego
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-main.pom
%add_to_maven_depmap org.jboss.security jboss-negotiation-main %{namedversion} JPP %{name}-main
install -m 644 parent/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-project.pom
%add_to_maven_depmap org.jboss.security jboss-negotiation-project %{namedversion} JPP %{name}-project
install -m 644 assembly/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
install -m 644 jboss-negotiation-common/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-common.pom
install -m 644 jboss-negotiation-extras/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-extras.pom
install -m 644 jboss-negotiation-ntlm/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-ntlm.pom
install -m 644 jboss-negotiation-spnego/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-spnego.pom

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 644 jboss-negotiation-toolkit/target/jboss-negotiation-toolkit.war $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{with_repolib}
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

tag=`echo %{namedversion}-brew`
sed -i "s/@VERSION@/$tag/g" %{SOURCE3}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE3}
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-common.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-extras.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-ntlm.jar $RPM_BUILD_ROOT%{repodirlib}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-spnego.jar $RPM_BUILD_ROOT%{repodirlib}

cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-main.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-main.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-project.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-project.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-common.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-common.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-extras.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-extras.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-ntlm.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-ntlm.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-spnego.pom $RPM_BUILD_ROOT%{repodirlib}/%{name}-spnego.pom

%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%{_datadir}/%{name}-%{version}

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Dec 09 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-2.SP3.3
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-deploy-plugin, maven-site-plugin, xpp3-minimal

* Thu Jun 3 2010 Yiqiao Wang <yiwang@redhat.com> - 0:2.0.3-2.SP3.2
- Merge From RHEL4

* Thu May 27 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.3-2.SP3.2
- Fix repolib location
- Do not include repolib content in main rpm

* Thu May 27 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.3-2.SP3.1
- Update to SP3

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-1.SP2.6.1
- rebuilt

* Wed Apr 21 2010 Hui Wang <huwang@redhat.com> - 0:2.0.3-1.SP2.6
- Rebuild

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> - 0:2.0.3-1.SP2.5
- Rebuild

* Tue Dec 01 2009 Yong Yang <yyang@redhat.com> - 0:2.0.3-1.SP2.4
- Change version in poms from 2.0.3.SP02 to 2.0.3.SP2

* Wed Nov 11 2009 Yong Yang <yyang@redhat.com> - 0:2.0.3-1.SP2.3
- Use namedversion(not version) to replace the @VERSION@ of component-info.xml 

* Tue Nov 10 2009 Yong Yang <yyang@redhat.com> - 0:2.0.3-1.SP2.2
- Add repolib

* Fri Sep 11 2009 Fernando Nasser <fnasser@redhat.com> - 0:2.0.3-1.SP2.1
- Update to SP2

* Tue Sep 08 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.3.1-1
- first release

